﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9.3
@EndOfDesignText@
Sub Process_Globals


End Sub


'DESCRIPTION
'This program combines my GUI front end and the Solver by Markus Stipp that
'won the quickest Sudoku solving competion in 2011 
'https://www.b4x.com/android/forum/threads/sudoku-solver-contest-we-have-a-winner.11834/

'The GUI allows:
'a) Manual entry of a puzzle
'b) Full manual solving as per a pen and paper puzzle
'c) A cheats assist showing the available spaces left for any selected number
'd) The ability to save a solution at any stage and restore (good For quesses)
'e) A one button autosolve using Markus's algorithms (I must admit that I dont understand how they work)
'f) Automatic counting of the totals for each number
'g) Checking for completeness of a totally filled in puzzle (81 numbers)


'DATA ENTRY
'Use the round Buttons 1 to 9. Only one can be selected at a time. Place on grid with touch
'Once selected you can add as many times to grid as you wish
'The "X" button removes an entries

'At each entry the totals for all numbers 1 to 9 are calculated and displayed as well as the total 
'number count. If this is 81 then the program automatically checks each square, row and column to
'ensure that each only has the numbers 1 to 9 with no repeats or ommissions.

'COMMANDS
'SHOW = Displays the locations on the grid of the positions where the selected number cannot be entered (Gray) and can
'be entered (Black).

'BACK CLEAR = Removes all background colour on the grid if you want to solve the hard way

'SOLVE ON = Starts Markus Stipp's autosolve routines

'CLEAR ALL = Clears the grid and the answers so allowing a fresh start . Does not clear a stored grid

'SAVE = Saves the present visible grid

'RESTORE = Restores the last saved grid

'Note: Save and restore are great if you guess a number and then want to go back to where your were


 'VERIFICATION
 'This is actioned when the TotalCount = 81 whether under manual entry or AutoSolve. 
 'The verification routines checks each Row, Col and Square to ensure only the numbers 1 to 9 are entered
 'with no duplicates and no ommissions.