﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9.3
@EndOfDesignText@
'Code module  Verification

Sub Process_Globals


End Sub

'==================================================================================================
'VERIFY GRID
'===================================================================================================
'Verifies Rows. Columns, Squares when the total grid count is 81
'Operates by placing a dummy variable "A" in TestArray for each cell found to have a number(text) in it.
'The positions in the test array coincide with the number in the cell
'This ensures that if two same numbers are in the row/col/square then the TestArray will only have one entry
'The Test array is checked to see if any position does not have a A.
'If this is so then the answer is false

Sub VerifySquaresDone(TopRow As Int, TopCol As Int) As Boolean
	Dim TestArray(10) As String
	Dim Answer As Boolean=True
	For i=TopRow To TopRow+2
		For j=TopCol To TopCol+2
			If Main.cells(j,i)>0 Then
				Dim Number As Int = Main.cells(j,i)
				TestArray(Number) ="A"
			End If
		Next
	Next
	For k = 1 To 9
		If TestArray(k)<>"A" Then
			Answer = False
		End If
	Next
	Return Answer
End Sub


Sub VerifyCompleteSquares As Boolean
	Return VerifySquaresDone(0,0) And VerifySquaresDone(0,3) And VerifySquaresDone(0,6) And VerifySquaresDone(3,0) And VerifySquaresDone(3,3) And VerifySquaresDone(3,6) _
	And VerifySquaresDone(6,0) And VerifySquaresDone(6,3) And VerifySquaresDone(6,6)
End Sub


Sub VerifyCompleteRows As Boolean
	Dim Answer As Boolean = True
	For i =0 To Main.NbCols-1
		Dim TestArray(10) As String
		For j=0 To Main.NbRows-1
			If Main.cells(j,i)>0 Then
				Dim Number As Int = Main.cells(j,i)
				TestArray(Number) ="A"
			End If
		Next
		For k = 1 To 9
			If TestArray(k)<>"A" Then
				Answer = False
			End If
		Next
	Next
	Return Answer
End Sub


Sub VerifyCompleteCols As Boolean
	Dim Answer As Boolean = True
	For i =0 To Main.NbRows-1
		Dim TestArray(10) As String
		For j=0 To Main.NbCols-1
			If Main.cells(i,j)>0 Then
				Dim Number As Int = Main.cells(i,j)
				TestArray(Number) ="A"
			End If
		Next
		For k = 1 To 9
			If TestArray(k)<>"A" Then
				Answer = False
			End If
		Next
	Next
	Return Answer
End Sub


Sub VerifyTotalGrid
	If VerifyCompleteRows And VerifyCompleteCols And VerifyCompleteSquares Then
		If Main.SolveOn Then
			Msgbox("AUTO SOLVE did it!","CORRECT!")
		Else
			Msgbox("YOU did it!","CORRECT!")
		End If
	
	Else
		Msgbox("Something is wrong", "INCORRECT")
	End If
	CallSub(Main,"ClearGridBackground")
End Sub